---
title: 'ScriptProcessorNode: audioprocess event'
slug: Web/API/ScriptProcessorNode/audioprocess_event
tags:
  - ScriptProcessorNode
  - Web Audio API
  - audioprocess
  - events
---
<div>{{APIRef("Web Audio API")}}{{deprecated_header}}</div>

<p>The audioprocess event of the {{domxref("ScriptProcessorNode")}} interface is fired when an input buffer of a script processor is ready to be processed.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Default action</th>
   <td>None</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("AudioProcessingEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("ScriptProcessorNode.onaudioprocess")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">scriptNode.addEventListener('audioprocess', function(audioProcessingEvent) {
  // The input buffer is a song we loaded earlier
  var inputBuffer = audioProcessingEvent.inputBuffer;

  // The output buffer contains the samples that will be modified and played
  var outputBuffer = audioProcessingEvent.outputBuffer;

  // Loop through the output channels (in this case there is only one)
  for (var channel = 0; channel &lt; outputBuffer.numberOfChannels; channel++) {
    var inputData = inputBuffer.getChannelData(channel);
    var outputData = outputBuffer.getChannelData(channel);

    // Loop through the 4096 samples
    for (var sample = 0; sample &lt; inputBuffer.length; sample++) {
      // make output equal to the same as the input
      outputData[sample] = inputData[sample];

      // add noise to each output sample
      outputData[sample] += ((Math.random() * 2) - 1) * 0.2;
    }
  }
})</pre>

<p>You could also set up the event handler using the {{domxref("ScriptProcessorNode.onaudioprocess")}} property:</p>

<pre class="brush: js">scriptNode.onaudioprocess = function(audioProcessingEvent) {
  ...
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#AudioProcessingEvent-section', 'AudioProcessingEvent')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ScriptProcessorNode.audioprocess_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("ScriptProcessorNode.onaudioprocess")}}</li>
 <li><a href="/en-US/docs/Web_Audio_API" title="/en-US/docs/CSS/Using_CSS_animations">Web Audio API</a></li>
</ul>
